/* Copyright (C) 1991 Free Software Foundation, Inc.

   This file is part of GNU Pascal Library.

   Function type external definitions.

The GNU Pascal Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU Pascal Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU Pascal Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/* Standard textfile WRITE routine, page & put in gpc_write.c */
extern void	_p_write ();		/* Write anything */
extern void	_p_page();		/* Text file PAGE routine */
extern void	_p_put();		/* put routine */

/* Standard textfile READ & get in gpc_read.c */
extern void	_p_read ();		/* Read anything */
extern void	_p_get();		/* get routine */

/* File management in gpc_file.c */
extern void	_p_rewrite();		/* rewrite routine */
extern void	_p_reset();		/* reset routine */
/* Extended file management in gpc_file.c */
extern void	_p_close();		/* Extension: Close file */
extern void	_p_extend ();		/* Extended Pascal: Append to file */

/* Random access routines for Extended Pascal in gpc_random.c */
extern void	_p_seekwrite ();	/* Random access write */
extern void	_p_seekread ();		/* Random access read */
extern void	_p_seekupdate ();	/*  Random access update */
/* empty(): should return type BOOLEAN */
extern char     _p_empty ();		/* is file empty? */
extern void	_p_update ();		/* Update file */
extern int	_p_position ();		/* Where are we in the file? */
extern int	_p_lastposition ();	/* How far could we go? */
extern void	_p_definesize ();	/* Gpc extension: define files size */
					/* needs ftruncate() */
/* Extended Pascal time routines in gpc_times.c */
extern void	_p_gettimestamp ();	/* Put date/time info in TimeStamp */
/* These should return string type */
extern char *	_p_date ();		/* Return time string from TimeStamp */
extern char *	_p_time ();		/* Return time string from TimeStamp */

/* Misc. Extended Pascal routines in gpc_misc.c */
extern void	_p_halt ();		/* Exits the program */

/* Standard HEAP management in gpc_heap.c */
extern void	_p_new();		/* new routine */
extern void	_p_dispose();		/* dispose routine */
/* heap management, GPC extension.
   You can use either dispose() or (mark() and release()) but not
   both in the same program. Decided on first usage. */
extern void	_p_mark();		/* mark routine */
extern void	_p_release();		/* release routine */

/* Standard MATHEMATICAL routines in gpc_math.c */
extern double	_p_atn();		/* math lib call */
extern double	_p_sqrt();		/* math lib call */
extern double	_p_lgn();		/* math lib call */
extern double	_p_exp();		/* math lib call */
extern double	_p_sin();		/* math lib call */
extern double	_p_cos();		/* math lib call */

/* Internal routines */
/* setup() is called before your Pascal program, final() is
   called after your program returns.  See gpc_setup.c. */
extern void	_p_initfdr();		/* initialize File Descriptor */
extern void	_p_setup();		/* setup routine */
extern void	_p_final();		/* final routine */

extern void	_p_makename();		/* Create a unique filename */
extern char     *_p_errmsg();		/* output error message */

extern void	_p_malloc_warning ();	/* GNU malloc warning */

extern void	_p_fflush ();		/* Flush the files in FDR Chain */

extern int	_p_bcmp ();		/* String compare */
