/* Copyright (C) 1991 Free Software Foundation, Inc.

   This file is part of GNU Pascal Library.

   Miscallenous routines for extended pascal support

The GNU Pascal Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU Pascal Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU Pascal Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include "gpcsym.h"

/* Extended Pascal HALT procedure for terminatingf the program.
   Gpc extension: return the VALUE as the exit status of the program
   		  this may not work for systems other than UN*X */
void
_p_halt (value)
int value;
{
    _p_warning (620);

    if (! Gpc_debug)
	exit(value);
}

/* Pascal string compare. This should be done with
   bcmp(3) but it only handles equality, not less or greater than
   as Pascal requires. For many machines it can be done with a single
   instruction (on vax with bcmp3) but currently no optimization is
   attempted. So, it's slow.

   null character is nothing special in Pascal strings.

   This function compares strings of LEN characters.

   Returns:
     0  if strings are equal
     1  if string s1 is GREATER than string s2
    -1  if string s1 is LESS than string s2
 */
int
_p_bcmp (s1, s2, len)
char *s1;
char *s2;
{
    if (len <= 0)
	_p_generic (704);
    while (--len && *s1 == *s2) {
	s1++;
	s2++;
    }
    return *s1 == *s2 ? 0 : (*s1 > *s2 ? 1 : -1);
}
