/* Copyright (C) 1991 Free Software Foundation, Inc.

   This file is part of GNU Pascal Library.

   Extended pascal routines.

The GNU Pascal Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU Pascal Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU Pascal Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include "gpcsym.h"

/* Include gcc tree.h for tree codes */
#include "tree.h"

/*
 * These are not used for anything yet.
 */

/*
 * BIND (f, b);
 *
 * Do an implementation dependent binding of a variable to an external extity.
 *
 * f is a BINDABLE variable_access, and b is an EXPRESSION of type BindingType
 * PACKED RECORD
 *   bound : Boolean;
 *   name  : 
 * with required field identifiers NAME and BOUND
 *
 * NAME is a variable-string-type
 * BOUND is of type Boolean
 */

struct BindList {
    struct BindList *next;	/* list pointer 	     */
    char 	    *var;	/* address of bound variable */
    enum tree_code   type;	/* type of bound variable    */
    int		     flags;	/* misc. flags		     */
};

/* List of bound variables */
static struct BindList *Bind_vars = (struct BindList *)NULL;

/* Free list of bindings */
static struct BindList *Bind_free = (struct BindList *)NULL;

void
_p_bind (addr, binding, type)
char *addr;			/* Address of the variable        */
BINDING binding;		/* Expression of type BindingType */
enum tree_code type;		/* type of the variable to bind   */
{
}

BINDING
_p_binding (addr)
char *addr;
{
}

void
_p_unbind (addr)
char *addr;			/* Address of the variable */
{
}

